' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2010                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVIL Sample Program
' p^\_CAO
'
' 쐬 : N.Moriguchi
'
'  : 2010/10/18 
'
' -----------------------------------------------------------------
Public Class Form_PTNDISPLAY

    'GbW\pI[o[CNX錾
    Private overlayEdge As FVIL.GDI.CFviOverlay = New FVIL.GDI.CFviOverlay()
    'p^\NX
    Private m_pattern_org As FVIL.Data.CFviPattern
    Private m_pattern_temp As FVIL.Data.CFviPattern
    'FPM2ev[gʒoNX
    Private template As FVIL.FPM2.CFviFPM2Template = New FVIL.FPM2.CFviFPM2Template()

    ''' <summary>
    ''' tH[
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' p^\tH[̏B
    ''' </remarks>
    Private Sub Form_PTNDISPLAY_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'p^{R{{bNX
        comboBoxPatternMag.Items.Clear()
        comboBoxPatternMag.Items.Add("1")
        comboBoxPatternMag.Items.Add("2")
        comboBoxPatternMag.Items.Add("4")
        comboBoxPatternMag.SelectedIndex = 0

        'J[\TCYR{{bNX
        comboBoxCursorSize.Items.Clear()
        comboBoxCursorSize.Items.Add("1")
        comboBoxCursorSize.Items.Add("3")
        comboBoxCursorSize.Items.Add("5")
        comboBoxCursorSize.Items.Add("7")
        comboBoxCursorSize.Items.Add("11")
        comboBoxCursorSize.SelectedIndex = 0

        'p^摜̕
        m_pattern_temp = m_pattern_org.Clone()
        ' p^\
        cFviImageView1.Image = m_pattern_temp
        'GbW\pI[o[C̒ǉ
        cFviImageView1.Display.Overlays.Add(overlayEdge)
        'ĕ`
        cFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' p^IuWFNg̊i[
    ''' </summary>
    ''' <param name="param"></param>
    ''' <remarks>
    ''' CtH[̃p^̎擾B
    ''' </remarks>
    Public Sub Set_pattern(ByVal param As FVIL.Data.CFviPattern)
        m_pattern_org = param
    End Sub

    ''' <summary>
    ''' ev[gʂ̊i[
    ''' </summary>
    ''' <param name="param"></param>
    ''' <remarks>
    ''' CtH[̃ev[gʂ̎擾B
    ''' </remarks>
    Public Sub Set_template(ByVal param As FVIL.FPM2.CFviFPM2Template)
        template = param
    End Sub

    ''' <summary>
    ''' p^\ɕύX
    ''' </summary>
    ''' <remarks>
    ''' p^\[hp\ύXB
    ''' </remarks>
    Public Sub Mode_Pattern()
        button_OK.Visible = False
        button_Cancel.Text = "߂"
        groupBoxPenForm.Visible = False
        groupBoxKindMask.Visible = False
    End Sub

    ''' <summary>
    ''' }XNݒɕύX
    ''' </summary>
    ''' <remarks>
    ''' }XNݒ胂[hp\ύXB
    ''' </remarks>
    Public Sub Mode_Mask()
        button_OK.Visible = True
        button_Cancel.Text = "Cancel"
        groupBoxPenForm.Visible = True
        groupBoxKindMask.Visible = True

        cFviImageView1.Display.MaskEnable = True
        cFviImageView1.Display.EssentialMaskEnable = True
        cFviImageView1.Display.OverlayPatternModify.Active = True
    End Sub

    ''' <summary>
    ''' GbW\`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' GbW`揈B
    ''' </remarks>
    Private Sub checkBoxPtnEdgeDisplay_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBoxPtnEdgeDisplay.CheckedChanged
        If (checkBoxPtnEdgeDisplay.Checked = True) Then
            Dim edges_image As List(Of FVIL.Edge.CFviEdgeData) = New List(Of FVIL.Edge.CFviEdgeData)
            'Ώۉ摜̃GbW_
            edges_image = template.GetFeatureEdges()

            'ʉ摜̕\
            For i As Integer = 0 To (edges_image.Count - 1)
                Dim edge As FVIL.Edge.CFviEdgeData = edges_image(i)
                'GbWʒu  }[N\ (0x)
                Dim position As FVIL.GDI.CFviGdiPoint = New FVIL.GDI.CFviGdiPoint(edge.Position)
                position.Size = New System.Drawing.Size(3, 1)
                position.Style = FVIL.GDI.FigureStyle.Arrow
                position.Angle = edges_image(i).Angle
                position.Pen.Color = System.Drawing.Color.FromArgb(0, 255, 0)
                overlayEdge.Figures.Add(position)
            Next
        Else
            overlayEdge.Figures.Clear()
        End If
        'ĕ`
        cFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' p^\{R{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' p^摜̕\{ύXB
    ''' </remarks>
    Private Sub comboBoxPatternMag_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboBoxPatternMag.SelectedIndexChanged
        '\{̐ݒ
        Select Case comboBoxPatternMag.SelectedIndex
            Case 0
                cFviImageView1.Display.Magnification = 1.0
            Case 1
                cFviImageView1.Display.Magnification = 2.0
            Case 2
                cFviImageView1.Display.Magnification = 4.0
            Case Else
                cFviImageView1.Display.Magnification = 1.0
        End Select
        'ĕ`
        cFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' yWI{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J[\yɕύXB
    ''' </remarks>
    Private Sub radioButtonModePen_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radioButtonModePen.CheckedChanged
        cFviImageView1.Display.OverlayPatternModify.MaskCursorMode = FVIL.GDI.MaskCursorMode.Write
    End Sub

    ''' <summary>
    ''' SWI{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J[\SɕύXB
    ''' </remarks>
    Private Sub radioButtonModeEraser_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radioButtonModeEraser.CheckedChanged
        cFviImageView1.Display.OverlayPatternModify.MaskCursorMode = FVIL.GDI.MaskCursorMode.Erase
    End Sub

    ''' <summary>
    ''' CursorSizeR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J[\TCYύXB
    ''' </remarks>
    Private Sub comboBoxCursorSize_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboBoxCursorSize.SelectedIndexChanged
        'J[\TCY̐ݒ
        Select Case comboBoxCursorSize.SelectedIndex
            Case 0
                cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = New Size(1, 1)
            Case 1
                cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = New Size(3, 3)
            Case 2
                cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = New Size(5, 5)
            Case 3
                cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = New Size(7, 7)
            Case 4
                cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = New Size(11, 11)
            Case Else
                cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = New Size(1, 1)
        End Select
    End Sub

    ''' <summary>
    ''' }XNWI{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J[\}XNҏWɕύXB
    ''' </remarks>
    Private Sub radioButtonModeMask_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radioButtonModeMask.CheckedChanged
        cFviImageView1.Display.OverlayPatternModify.MaskBit = FVIL.Data.Pattern.MaskBit.MASK
    End Sub

    ''' <summary>
    ''' sWI{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J[\sҏWɕύXB
    ''' </remarks>
    Private Sub radioButtonModeEssential_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radioButtonModeEssential.CheckedChanged
        cFviImageView1.Display.OverlayPatternModify.MaskBit = FVIL.Data.Pattern.MaskBit.ESSENTIAL
    End Sub

    ''' <summary>
    ''' OK{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' CtH[̃p^f[^XVB
    ''' </remarks>
    Private Sub button_OK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_OK.Click
        'p^f[^Rs[
        m_pattern_org.CopyFrom(m_pattern_temp)
        Close()
    End Sub

    ''' <summary>
    ''' LZ{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' p^\tH[ł̐ݒjB
    ''' </remarks>
    Private Sub button_Cancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_Cancel.Click
        Close()
    End Sub

    ''' <summary>
    ''' I
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' tH[IB
    ''' </remarks>
    Private Sub Form_PTNDISPLAY_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        checkBoxPtnEdgeDisplay.Checked = False
        overlayEdge.Figures.Clear()
        'ĕ`
        cFviImageView1.Refresh()
    End Sub

End Class